/* arquivo.h */

#include <stdio.h>

#define NOME_ARQ_INDICE "AGENDA.IND"
#define NOME_ARQ_BASE   "AGENDA.BSE"

#define VERDADEIRO 1
#define FALSO      0

#define SUCESSO    1
#define ERRO       0

#define DELETADO   "*DELETADO*"  // estado de um registro deletado

class disco {

protected:

  FILE *fp_arq_ind,              // arquivo utilizado para indice

       *fp_arq_base;             // arquivo que contem a base de dados

  char *cpz_identif_arq_ind,     // nome do arquivo de indices no DOS

       *cpz_identif_arq_base;    // nome da entrada do arquivo de base no DOS

public:

  disco (void);

  disco (const char *cpz_nome_arq_ind, const char *cpz_nome_arq_base);

  void crie_arquivos (const char *cpz_nome_arq_ind,
		      const char *cpz_nome_arq_base);

  /* funcoes membro para o arquivo de indice */

  void inic_arq_ind (void)
  {

    fseek (fp_arq_ind, 0, SEEK_SET);

  };

  void leia_arq_ind (char *cpz_buffer, const int i_tam,
		    const int i_posicao);

  int leia_arq_ind (char *cpz_buffer, const int i_tam);

  int grave_arq_ind (int num_regs, char *cpz_buffer, const int i_tam);

  void grave_arq_ind (char *cpz_buffer, const int i_posicao,
		      const int i_tam);

  void delete_reg_arq_ind (const int i_tam, const int i_posic);

  /* funcoes membro para o arquivo de base */

  void leia_arq_base (char *cpz_buffer, const int i_tam, const int i_posic);

  int grave_arq_base (int num_regs, char *cpz_buffer, const int i_tam);

  void grave_arq_base (char *cpz_buffer, const int i_posicao,
		       const int i_tam);

  void delete_reg_arq_base (const int i_tam, const int i_posic);

  ~disco (void);

};

